import Webworker from './web-worker';
import CryptoBin from './crypto-bin';


var getCrypto = common => {
  var cryptoWorker = CryptoBin();
  var useWorker = common.use.webworker;

  function _ref(args) {
    return webWorker.run('factorize', args);
  }

  function _ref2(args) {
    return webWorker.run('mod-pow', args);
  }

  if (useWorker) {
    try {
      var webWorker = Webworker.of();
      var factorize = _ref;

      var modPow = _ref2;

      cryptoWorker.factorize = factorize;
      cryptoWorker.modPow = modPow;
    } catch (err) {
      useWorker = false;
    }
  }
  common.use.webworker = useWorker;

  return cryptoWorker;
};

export default getCrypto;
//# sourceMappingURL=index.js.map