
import arrify from '../util/arrify';

var normalizeScope = scope => arrify(scope);

var reduceStarter = [];

function _ref(acc, val) {
  return acc.concat(normalizeScope(val));
}

var combineScope = (...scopes) => scopes.reduce(_ref, reduceStarter);

class ScopedEmitter {
  constructor(scope, parent) {
    this.on = (event, listener) => {
      var fullEvent = this.scope.concat(normalizeScope(event));
      // console.log('on', 'event', event, 'fullEvent', fullEvent, 'scope', this.scope, normalizeScope(event))
      return this.root.on(fullEvent, listener);
    };

    this.off = (event, listener) => {
      var fullEvent = [...this.scope, event].join('.');
      return this.root.off(fullEvent, listener);
    };

    this.emit = (event, ...values) => {
      var fullEvent = this.scope.concat(normalizeScope(event));
      // console.log('emit', 'event', event, 'fullEvent', fullEvent, 'scope', this.scope, normalizeScope(event))
      return this.root.emit(fullEvent, ...values);
    };

    if (parent instanceof ScopedEmitter) {
      this.root = parent.root;
      this.scope = combineScope(parent.scope, scope);
    } else {
      this.scope = normalizeScope(scope);
      this.root = parent;
    }
  }

}

export default ScopedEmitter;
//# sourceMappingURL=scoped-emitter.js.map