'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.chooseServer = undefined;

var _propEq = require('ramda/src/propEq');

var _propEq2 = _interopRequireDefault(_propEq);

var _find = require('ramda/src/find');

var _find2 = _interopRequireDefault(_find);

var _pipe = require('ramda/src/pipe');

var _pipe2 = _interopRequireDefault(_pipe);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var sslSubdomains = ['pluto', 'venus', 'aurora', 'vesta', 'flora'];

var devDC = [{ id: 1, host: '149.154.175.10', port: 80 }, { id: 2, host: '149.154.167.40', port: 80 }, { id: 3, host: '149.154.175.117', port: 80 }];

var prodDC = [{ id: 1, host: '149.154.175.50', port: 80 }, { id: 2, host: '149.154.167.51', port: 80 }, { id: 3, host: '149.154.175.100', port: 80 }, { id: 4, host: '149.154.167.91', port: 80 }, { id: 5, host: '149.154.171.5', port: 80 }];

var portString = ({ port = 80 }) => port === 80 ? '' : `:${port}`;

var findById = (0, _pipe2.default)((0, _propEq2.default)('id'), _find2.default);

var chooseServer = exports.chooseServer = (chosenServers, serverConfig = {}) => (dcID, upload = false) => {

  var {
    dev = false,
    webogram = false,
    dcList = dev ? devDC : prodDC
  } = serverConfig;

  if (typeof chosenServers[dcID] === 'string') return chosenServers[dcID];

  if (webogram) {
    var subdomain = sslSubdomains[dcID - 1] + (upload ? '-1' : '');
    var path = dev ? 'apiw_test1' : 'apiw1';
    var chosenServer = `https://${subdomain}.web.telegram.org/${path}`;
    return chosenServer; //TODO Possibly bug. Isn't it necessary? chosenServers[dcID] = chosenServer
  }
  var dcOption = findById(dcID)(dcList);
  if (dcOption) {
    var _chosenServer = `http://${dcOption.host}${portString(dcOption)}/apiw1`;
    chosenServers[dcID] = _chosenServer;
  }
  return false;
};
//# sourceMappingURL=dc-configurator.js.map